unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Controls, Forms, WMPLib_TLB,
  Dialogs, Classes, OleCtrls, ExtCtrls, StdCtrls, Graphics;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure PlayerClick(Sender: TObject; nButton,
      nShiftState: Smallint; fX, fY: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    //  TWindowsMediaPlayer 𕔕iuɃo[ƂĒ`
    FPlayer: TWindowsMediaPlayer;
    //  TWindowsMediaPlayer 蒼
    procedure ReCreatePlayer();
  private
    //  TCYIuԂ𑨂
    FResized: Boolean;
    procedure OnResized();
    procedure WMEXITSIZEMOVE(var Message: TMessage); message WM_EXITSIZEMOVE;

  public
  end;

var
  Form1: TForm1;

implementation

uses
    Types, Info;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  TCYIuԂ𑨂
//  [Delphi-ML:20299] Window̃TCYCxgɂċĂB
procedure TForm1.WMEXITSIZEMOVE(var Message: TMessage);
begin
    if FResized then OnResized();
    inherited;
end;

//-----------------------------------------------------------------------------
//  TCYCxg
procedure TForm1.OnResized;
var
    LURL: String;
    LPosition: Double;
    LVolume: Integer;
begin
    //  ł邾oĂ
    LPosition := 0;
    LVolume := -1;
    LURL := '';
    if (FPlayer <> nil) then
    begin
        LURL := FPlayer.URL;
        LVolume :=  FPlayer.settings.volume;
        if (FPlayer.currentMedia <> nil) then
        begin
            LPosition := FPlayer.controls.currentPosition;
        end;
        FPlayer.Hide();
    end;

    //  vC[j
    FPlayer.Free();
    FPlayer := nil;
    //  
    ReCreatePlayer();

    //  ł邾Č
    FPlayer.URL := LURL;
    if (LVolume <> -1) then FPlayer.settings.volume := LVolume;
    if (LPosition > 0) then
    begin
        FPlayer.controls.currentPosition := LPosition;
    end;

    //  \
    FPlayer.Show();

    Caption := IntToStr(StrToIntDef(Caption, 0) + 1);

    //  Ō1𑨂邽߂̃tOOFF
    FResized := False;
end;

//-----------------------------------------------------------------------------
//  tH[TCYύX
procedure TForm1.FormResize(Sender: TObject);
begin
    //  Ō1𑨂邽߂̃tOON
    FResized := True;
end;

//-----------------------------------------------------------------------------
//  TWindowsMediaPlayer 蒼
//  http://hpcgi1.nifty.com/MADIA/DelphiBBS/wwwlng.cgi?print+200711/07110026.txt
//  WindowsMediaPlayer1ς̍Đ\ɂ́H
procedure TForm1.ReCreatePlayer();
var
    LCore: IWMPCore;
    LPlayer4Disp: WMPLib_TLB.IWMPPlayer4Disp;
begin
    //  ĂȂ
    if not Assigned(FPlayer) then
    begin
        //  
        FPlayer := TWindowsMediaPlayer.Create(Self);
        //  TWindowsMediaPlayer R|̃TCY Form ̃TCYɍ킹
        FPlayer.Align := alClient;
        //  Align ̌ Parent ݒ(tƂ)
        FPlayer.Parent := Panel2;
        //  vC[̃C^[tF[Xo(?)
        LCore := FPlayer.ControlInterface;
        if Assigned(LCore) then
        begin
            //  StretchToFit ĂC^[tF[Xւ̎QƂo
            LCore.QueryInterface(WMPLib_TLB.IWMPPlayer4Disp, LPlayer4Disp);
            if Assigned(LPlayer4Disp) then
            begin
                //  ŁAݒ肷
                LPlayer4Disp.StretchToFit := True;
            end;
        end;

        FPlayer.OnClick := PlayerClick;
    end;
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TForm1.FormCreate(Sender: TObject);
begin
    FPlayer := nil;
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TForm1.FormDestroy(Sender: TObject);
begin
    //  vC[j
    FPlayer.Free();
    FPlayer := nil;
end;

//-----------------------------------------------------------------------------
//  tH[\
procedure TForm1.FormShow(Sender: TObject);
begin
    OnResized();
end;

//-----------------------------------------------------------------------------
//  t@CI
procedure TForm1.Button1Click(Sender: TObject);
begin
    if (OpenDialog1.Execute()) then
    begin
        FPlayer.URL := OpenDialog1.FileName;
    end;
end;

//-----------------------------------------------------------------------------
//  vC[̃NbNCxg
procedure TForm1.PlayerClick(Sender: TObject; nButton,
  nShiftState: Smallint; fX, fY: Integer);
begin
    //
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  Ƃ߂
procedure TForm1.Button3Click(Sender: TObject);
var
    LSender: TComponent;
begin
    LSender := TComponent(Sender);
    if (FPlayer.currentMedia <> nil) then
    begin
        FPlayer.controls.currentPosition
            := FPlayer.controls.currentPosition + LSender.Tag;
    end;
end;

end.
